


# Y : data
# pred.period :prediction
# period : the years considered 
# (must be the same length then the number of rows of Y and pred.period )

custplot1=function(Y,pred.period,period){
op=par()
epsca=c(3,4,.1,0.1)
par(oma=c(.1,.1,.1,0),mar=c(1, 0, 0, .0)+epsca,cex.lab=1.5,xaxs="i")

nseason=dim(Y)[2]
time=rep(period,each=nseason)+rep((1:nseason)/(nseason+1),times=length(period))
Ytemp=as.vector(t(Y))
Yhattemp=as.vector(t(pred.period))
plot(time,Ytemp,col="red",xlab="",ylab="",pch=".")

for(i in seq(-50,50,by = 5)){
  abline(h =i, col = "gray60",lty=5)
  }

lines(time,Yhattemp,col='blue')
title(ylab=expression(paste('Temperature (',degree~C,')')),line = 2.3 )
title(xlab=expression("Year"),line = 2.7)

par(op)
}


###############################################################################
#plot of figure 1 : 
#decomposition of made model (9) and two annual cycles in the training period) 

# Y : data
# pred.period :prediction
# period : the years considered 
# (must be the same length then the number of rows of Y and pred.period )

custplot2=function(Y,fghHatYears,yearC1=NULL,yearC2=NULL){



fhat=fghHatYears$fhat
ghat=fghHatYears$ghat
hhat=fghHatYears$hhat
years=fghHatYears$years

  if(is.null(yearC1)&is.null(yearC2)){
    yearC1=years[1]
    yearC2=rev(years)[1]
  }

  pred.C1=as.vector(predict.NormNSta(fghHatYears=fghHatYears,new.years=yearC1))
  pred.C2=as.vector(predict.NormNSta(fghHatYears=fghHatYears,new.years=yearC2))
  
######
# #plot
# fhat=s.mu
# ghat=predict(s, 1900:annFinTrain)$y-mean(predict(s, 1900:annFinTrain)$y)
# hhat=s.g


Yhat=matrix(data=1,nrow = length(ghat),ncol=1)%*%matrix(data=fhat,nrow=1)+(ghat)%*%t(hhat) 

p = dim(Y)[2]
n = dim(Y)[1]

################
#plot of the different cycle
################



require(grid)

dilatJour=365/p
 

epsca=c(2,5,1,0.1)#marges interieures (bas ,gauche,haut,droite)
cexLabAx1=1.3 
cexLabAx2=1.3 
Haut=10

op=par()
split.screen(c(3,1))
split.screen(c(1,2),screen=1)
split.screen(c(1,2),screen=3)
screen(4);
par(oma=c(.1,.1,.1,0),mar=c(0, 0, 0, .0)+epsca,cex.lab=1.1)
plot((1:p)*dilatJour,fhat,type = "n",ylab="",xaxt = "n",yaxt = "n",xlab="" ,cex=0.3,xaxs="i")
points((1:p)*dilatJour,fhat,col="blue",type = "l",xlab="Jours ",ylab="Temperature",lwd=2)

axis(1,c(15.5,45.0,74.5,105.0,135.5,166.0,196.5,227.5,258.0,288.5,319.0,349.5)[(1:6)*2], c("J","F","M","A","M","J","J","A","S","O","N","D")[(1:6)*2],cex.axis=cexLabAx1,las=1,tick = F,line = -.7)
axis(1,c(15.5,45.0,74.5,105.0,135.5,166.0,196.5,227.5,258.0,288.5,319.0,349.5)[(0:5)*2+1], c("J","F","M","A","M","J","J","A","S","O","N","D")[(0:5)*2+1],cex.axis=cexLabAx1,las=1,tick = F,line = -.7)
axis(1, cumsum(c(1,-1,31,28,31,30,31,30,31,31,30,31,30,31)),cex.axis=1,las=1,tick = T,labels = F)
axis(2,cex.axis=1,las=1,line=0,labels = F)
axis(2,cex.axis=cexLabAx2,las=1,line=-0.3,tick = F)


title(ylab=expression(paste('Temperature (',degree~C,')')),cex.main=1,line = 2.  )

for(i in seq(-50,50,by = 1)){
  if(i%%5==0){abline(h =i, col = "gray60",lty=5)}else{
    abline(h =i, col = "gray60",lty=2)
  }
}
for(i in cumsum(c(0,31,28,31,30,31,30,31,31,30,31,30,31))){
  abline(v=i, col = "gray60",lty=2)
}




screen(5);
par(oma=c(.1,.1,.1,0),mar=c(0, 0, 0, .0)+epsca,cex.lab=1.5,xaxs="i")
plot((1:p)*dilatJour,hhat,type = "n",lwd=2,xlab="",ylab="",xaxt="n",yaxt="n")
points((1:p)*dilatJour,hhat,col="blue",type = "l",lwd=2,xlab="Jours ",ylab="")
axis(1,c(15.5,45.0,74.5,105.0,135.5,166.0,196.5,227.5,258.0,288.5,319.0,349.5)[(1:6)*2], c("J","F","M","A","M","J","J","A","S","O","N","D")[(1:6)*2],cex.axis=cexLabAx1,las=1,tick = F,line = -.7)
axis(1,c(15.5,45.0,74.5,105.0,135.5,166.0,196.5,227.5,258.0,288.5,319.0,349.5)[(0:5)*2+1], c("J","F","M","A","M","J","J","A","S","O","N","D")[(0:5)*2+1],cex.axis=cexLabAx1,las=1,tick = F,line = -.7)

axis(1, cumsum(c(1,-1,31,28,31,30,31,30,31,31,30,31,30,31)),cex.axis=1.5,las=1,tick = T,labels = F)
axis(2,cex.axis=1,las=1,line=0,labels = F)
axis(2,cex.axis=cexLabAx2,las=1,line=-0.3,tick = F)

#title(paste("h delta cycle  rho=",rhoph ),cex.main = 1.1,xlab="",ylab="",line=0.3)

for(i in seq(-10,10,by = 0.2)){
  abline(h =i, col = "gray60",lty=2)
}
for(i in cumsum(c(0,31,28,31,30,31,30,31,31,30,31,30,31))){
  abline(v=i, col = "gray60",lty=2)
}


#g donnees centrees
screen(2);
par(oma=c(.1,.1,.1,0),mar=c(1, 0, 0, .0)+epsca,cex.lab=1.1,xaxs="i")
plot((0:(n-1))+1900,ghat,col="blue",type = "l",xlab="",ylab="",xaxt="n",yaxt="n",ltw=3)
title(ylab=expression(paste('Temperature (',degree~C,')')),cex.main=1,line = 2.)
title(xlab=expression("Year"),line = 1.7)
axis(2,cex.axis=1,las=1,line=0,labels = F)
axis(2,cex.axis=cexLabAx2,las=1,line=-0.3,tick = F)

axis(1,cex.axis=1.5,las=1,line=-0.0,labels = F)
axis(1,cex.axis=cexLabAx2,las=1,line=-0.5,tick = F)

for(i in -20:20){
  abline(h =i, col = "gray60",lty=2)
}
for(i in ((0:(n-1))+1900)){
  if(i%%10==0){abline(v=i, col = "gray60",lty=2)}
}


screen(6);
par(oma=c(.1,.1,.1,0),mar=c(0, 0, 0, .0)+epsca,cex.lab=1.1,xaxs="i")
plot(c((1:p)*dilatJour,(1:p)*dilatJour),c(Y[which(years==yearC1),],Y[which(years==yearC2),]),type="n",col="red",yaxt = "n",xaxt = "n",xlab="",ylab="" ,cex=0.3 )
points((1:p)*dilatJour,Y[which(years==yearC1),],type="l",col="red",yaxt = "n",xaxt = "n",xlab="",ylab="" ,cex=0.3 )
points((1:p)*dilatJour,pred.C1,type="l",col="blue")
axis(1,c(15.5,45.0,74.5,105.0,135.5,166.0,196.5,227.5,258.0,288.5,319.0,349.5)[(1:6)*2], c("J","F","M","A","M","J","J","A","S","O","N","D")[(1:6)*2],cex.axis=cexLabAx1,las=1,tick = F,line = -.7)
axis(1,c(15.5,45.0,74.5,105.0,135.5,166.0,196.5,227.5,258.0,288.5,319.0,349.5)[(0:5)*2+1], c("J","F","M","A","M","J","J","A","S","O","N","D")[(0:5)*2+1],cex.axis=cexLabAx1,las=1,tick = F,line = -.7)


axis(1, cumsum(c(1,-1,31,28,31,30,31,30,31,31,30,31,30,31)),cex.axis=1.5,las=1,tick = T,labels = F)
axis(2,cex.axis=1,las=1,line=0,labels = F)
axis(2,cex.axis=cexLabAx2,las=1,line=-0.3,tick = F)

#title("Annee 1900",cex.main = 1.3,line = 0.3)
title(ylab=expression(paste('Temperature (',degree~C,')')),cex.main=1,line = 2. )
for(i in seq(-50,50,by = 1)){
  if(i%%5==0){abline(h =i, col = "gray60",lty=5)}
}
for(i in cumsum(c(0,31,28,31,30,31,30,31,31,30,31,30,31))){
  abline(v=i, col = "gray60",lty=2)
}


#par(oma=c(.1,0,.1,.1),mar=c(3, 0, 2, 1),cex.lab=1.5)
screen(7);
par(oma=c(.1,.1,.1,0),mar=c(0, 0, 0, .0)+epsca,cex.lab=1.5,xaxs="i")
plot(c((1:p)*dilatJour,(1:p)*dilatJour),c(Y[which(years==yearC1),],Y[which(years==yearC2),]),type="n",col="red",yaxt = "n",xaxt = "n",xlab="",ylab="" ,cex=0.3 )
points((1:p)*dilatJour,Y[which(years==yearC2),],type="l",col="red",yaxt = "n",xaxt = "n",xlab="",ylab="" ,cex=0.3 )
points((1:p)*dilatJour,pred.C2,type="l",col="blue")

axis(1,c(15.5,45.0,74.5,105.0,135.5,166.0,196.5,227.5,258.0,288.5,319.0,349.5)[(1:6)*2], c("J","F","M","A","M","J","J","A","S","O","N","D")[(1:6)*2],cex.axis=cexLabAx1,las=1,tick = F,line = -.7)
axis(1,c(15.5,45.0,74.5,105.0,135.5,166.0,196.5,227.5,258.0,288.5,319.0,349.5)[(0:5)*2+1], c("J","F","M","A","M","J","J","A","S","O","N","D")[(0:5)*2+1],cex.axis=cexLabAx1,las=1,tick = F,line = -.7)

axis(1, cumsum(c(1,-1,31,28,31,30,31,30,31,31,30,31,30,31)),cex.axis=1.5,las=1,tick = T,labels = F)
axis(2,cex.axis=1,las=1,line=0,labels = F)
axis(2,cex.axis=cexLabAx2,las=1,line=-0.3,tick = F)

#title(paste("Annee ",(n-1)+1900,sep=""),cex.main = 1.3,xlab="",ylab="",line=0.3)
for(i in seq(-50,50,by = 1)){
  if(i%%5==0){abline(h =i, col = "gray60",lty=5)}
}
for(i in cumsum(c(0,31,28,31,30,31,30,31,31,30,31,30,31))){
  abline(v=i, col = "gray60",lty=2)
}

grid.text(label = c("a)","b)","c)","d)","e)"),x=c(0.01,0.51,0.01,0.01,0.51),y=c(1,1,0.67,0.335,0.335),vjust = 1,hjust = 0,gp=gpar(fontsize=34),draw = T)
grid.text(label = c("a)","b)","c)","d)","e)"),x=c(0.01,0.51,0.01,0.01,0.51),y=c(1,1,0.67,0.335,0.335),vjust = 1,hjust = 0,gp=gpar(fontsize=34),draw = T)

#par(op)


}
